## python-cmake-build-extension 0.6.0

=== debian/changelog ===
python-cmake-build-extension (0.6.0-2) unstable; urgency=medium

  * Fix copy&paste bug in patch
  * Depend on gcc for autopkgtest
  * Make sure CMake picks the correct Python version

 -- Timo Röhling <roehling@debian.org>  Mon, 10 Jun 2024 23:06:54 +0200

python-cmake-build-extension (0.6.0-1) unstable; urgency=medium

  * Initial release (Closes: #1072781)

 -- Timo Röhling <roehling@debian.org>  Sat, 08 Jun 2024 00:21:23 +0200

## python-cmake-build-extension 0.6.1

=== example/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18.2)
project(MyMath VERSION 1.0)

# C++ standard
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_C_EXTENSIONS OFF)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Common installation directories
include(GNUInstallDirs)

# Use -fPIC even if statically compiled
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

# ============
# math library
# ============

# Create the mymath library
add_library(mymath
    src/mymath.h
    src/mymath.cpp)
add_library(MyMath::mymath ALIAS mymath)

set_target_properties(mymath PROPERTIES
    PUBLIC_HEADER src/mymath.h)

target_include_directories(mymath PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)

# =======================
# print_answer executable
# =======================

# Create the print_answer executable
add_executable(print_answer src/print_answer.cpp)

# =======
# Install
# =======

# See official documentation on exporting targets:
# https://cmake.org/cmake/help/latest/guide/importing-exporting/index.html#exporting-targets

# Install the target with C++ code
install(
    TARGETS mymath print_answer
    EXPORT MyMathTargets
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

# Install the exported targets
install(
    EXPORT MyMathTargets
    FILE MyMathTargets.cmake
    NAMESPACE MyMath::
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/MyMath)

# Create a CMake package
include(CMakePackageConfigHelpers)

# Prepare the Config.cmake.in content
set(PACKAGE_INIT_MACRO "@PACKAGE_INIT@")
set(CONFIG_CMAKE_IN "\
@PACKAGE_INIT_MACRO@\n\
include(\"\${CMAKE_CURRENT_LIST_DIR}/MyMathTargets.cmake\")\n\
check_required_components(MyMath)\n"
)

# Create Config.cmake.in
file(CONFIGURE
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/Config.cmake.in
    CONTENT ${CONFIG_CMAKE_IN}
    @ONLY)

# Create MyMathConfig.cmake
configure_package_config_file(
    ${CMAKE_CURRENT_BINARY_DIR}/Config.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/MyMathConfig.cmake
    INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/MyMath)

# Create MyMathConfigVersion.cmake
write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/MyMathConfigVersion.cmake"
    VERSION "${version}"
    COMPATIBILITY AnyNewerVersion
)

# Install CMake package files
install(FILES
    "${CMAKE_CURRENT_BINARY_DIR}/MyMathConfig.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/MyMathConfigVersion.cmake"
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/MyMath
)

# ===============
# Python bindings
# ===============

# Find Python3 and NumPy
find_package(Python3 COMPONENTS Interpreter Development.Module NumPy REQUIRED)

# Handle where to install the resulting Python package
if(CALL_FROM_SETUP_PY)
    # The CMakeExtension will set CMAKE_INSTALL_PREFIX to the root
    # of the resulting wheel archive
    set(MYMATH_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
else()
    # The Python package is installed directly in the folder of the
    # detected interpreter (system, user, or virtualenv)
    set(MYMATH_INSTALL_PREFIX ${Python3_SITELIB})
endif()

# =============
# SWIG bindings
# =============

if(EXAMPLE_WITH_SWIG)
    # Rename the executable
    set_target_properties(print_answer PROPERTIES OUTPUT_NAME print_answer_swig)

    # Add the bindings
    add_subdirectory(bindings_swig)
endif()

# =================
# Pybind11 bindings
# =================

if(EXAMPLE_WITH_PYBIND11)
    # Rename the executable
    set_target_properties(print_answer PROPERTIES OUTPUT_NAME print_answer_pybind11)

    # Add the bindings
    add_subdirectory(bindings_pybind11)
endif()

=== example/bindings_pybind11/CMakeLists.txt ===
find_package(pybind11 REQUIRED)
find_package(Eigen3 REQUIRED NO_MODULE)

# =======
# Library
# =======

# Create the pybind11 library
pybind11_add_module(pybind11_bindings MODULE bindings.cpp)

target_link_libraries(pybind11_bindings
    PRIVATE MyMath::mymath Eigen3::Eigen)

# The name of the shared library must match the module name
set_target_properties(pybind11_bindings PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/mymath
    OUTPUT_NAME "bindings")

# =======
# Install
# =======

# Install the pybind11 library
install(
    TARGETS pybind11_bindings
    COMPONENT bindings
    LIBRARY DESTINATION ${MYMATH_INSTALL_PREFIX}
    ARCHIVE DESTINATION ${MYMATH_INSTALL_PREFIX}
    RUNTIME DESTINATION ${MYMATH_INSTALL_PREFIX})

=== example/bindings_swig/CMakeLists.txt ===
# Set SWIG policies
cmake_policy(SET CMP0078 NEW)
cmake_policy(SET CMP0086 NEW)

find_package(SWIG 4.0 REQUIRED)
set(UseSWIG_MODULE_VERSION 2)
include(${SWIG_USE_FILE})

# =======
# Library
# =======

# The name of the shared library must match the module name
set_source_files_properties(bindings.i PROPERTIES
    CPLUSPLUS ON
    SWIG_MODULE_NAME "bindings")

# Create the SWIG library
swig_add_library(swig_bindings
    TYPE MODULE
    LANGUAGE python
    OUTPUT_DIR ${CMAKE_CURRENT_BINARY_DIR}/mymath
    OUTFILE_DIR ${CMAKE_CURRENT_BINARY_DIR}
    SOURCES bindings.i)

target_link_libraries(swig_bindings
    PRIVATE MyMath::mymath Python3::NumPy)

set_target_properties(swig_bindings PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/mymath)

set_property(TARGET swig_bindings PROPERTY
    SWIG_USE_TARGET_INCLUDE_DIRECTORIES TRUE)

# Enable parsing the doxygen comments
set_property(TARGET swig_bindings
    PROPERTY SWIG_COMPILE_OPTIONS -doxygen)

# Add dependency to numpy.i
set_property(
    TARGET swig_bindings
    PROPERTY SWIG_DEPENDS numpy.i)

# =======
# Install
# =======

# Get the autogenerated Python file
get_property(WRAPPER_PY_FILE
    TARGET swig_bindings
    PROPERTY SWIG_SUPPORT_FILES)

# Install the autogenerated Python file
install(
    FILES ${WRAPPER_PY_FILE}
    DESTINATION ${MYMATH_INSTALL_PREFIX}
    COMPONENT bindings)

# Install the SWIG library
install(
    TARGETS swig_bindings
    COMPONENT bindings
    LIBRARY DESTINATION ${MYMATH_INSTALL_PREFIX}
    ARCHIVE DESTINATION ${MYMATH_INSTALL_PREFIX}
    RUNTIME DESTINATION ${MYMATH_INSTALL_PREFIX})

=== debian/changelog ===
python-cmake-build-extension (0.6.1-2) unstable; urgency=medium

  * Fix compatibility with SWIG 4.3 (Closes: #1090904)

 -- Timo Röhling <roehling@debian.org>  Mon, 23 Dec 2024 01:13:21 +0100

python-cmake-build-extension (0.6.1-1) unstable; urgency=medium

  * New upstream version 0.6.1
  * Refresh patch (no functional changes)

 -- Timo Röhling <roehling@debian.org>  Fri, 13 Sep 2024 13:41:15 +0200

=== debian/control ===
Source: python-cmake-build-extension
Section: python
Priority: optional
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders:
 Timo Röhling <roehling@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 dh-sequence-python3,
 pybuild-plugin-pyproject,
 python3-all,
 python3-setuptools,
 python3-setuptools-scm,
Homepage: https://github.com/diegoferigo/cmake-build-extension
Standards-Version: 4.7.0
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/python-team/packages/cmake-build-extension.git
Vcs-Browser: https://salsa.debian.org/python-team/packages/cmake-build-extension
Description: Setuptools extension to build and package CMake projects
 This extension aims to simplify the integration of C++ projects based on CMake
 with Python packaging tools. CMake provides out-of-the-box support to either
 SWIG and pybind11, that are two among the most used projects to create Python
 bindings from C++ sources.
 .
 If you have any experience with these hybrid projects, you know the challenges
 to make packaging right! This project takes inspiration from pre-existing
 examples (pybind/cmake_example, among many others) and provides a simple,
 flexible, and reusable setuptools extension with the following features:
 .
  * Bridge between CMake projects and Python packaging
  * Configure and build the CMake project from setup.py
  * Install the CMake project in the resulting Python package
  * Allow passing custom CMake options
  * Allow creating a top-level __init__.py
  * Expose C++ executables to the Python environment
  * Provide a context manager to import CPython modules reliably on all major
    OSs
  * Disable the C++ extension in editable installations (requiring to manually
    call CMake to install the C++ project)

Package: python3-cmake-build-extension
Architecture: all
Depends:
 ${misc:Depends},
 ${python3:Depends},
Recommends:
 cmake,
 ninja-build,
Description: ${source:Synopsis}
 ${source:Extended-Description}

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export PYBUILD_NAME = cmake-build-extension
export SETUPTOOLS_SCM_PRETEND_VERSION = $(DEB_VERSION_UPSTREAM)

%:
	dh $@ --buildsystem=pybuild

=== debian/tests/control ===
Tests: build-example
Depends:
 @,
 cmake,
 gcc,
 g++,
 libeigen3-dev,
 ninja-build,
 python3-all-dev,
 python3-build,
 python3-numpy,
 python3-pybind11,
 python3-setuptools,
 python3-setuptools-scm,
 swig,
Restrictions: allow-stderr

Tests: build-example-debianized
Depends:
 @,
 cmake,
 dpkg-dev,
 gcc,
 g++,
 libeigen3-dev,
 ninja-build,
 python3-all-dev,
 python3-build,
 python3-numpy,
 python3-pybind11,
 python3-setuptools,
 python3-setuptools-scm,
 swig,
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts=searchmode=plain,filenamemangle=s%(?:.*?/)?v?@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,uversionmangle=s%[.-]?(a|b|c|rc|dev|pre)%~$1% \
 https://api.github.com/repos/diegoferigo/cmake-build-extension/tags \
 tarball/(?:[^"]*?/)?[a-z]*@ANY_VERSION@
